<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../../stylesheet.css">
<link rel="start" href="../../../overview-summary.html">

<title>doclets/standard/htmlWriter.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/standard/htmlwriter.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>doclets/standard/htmlWriter.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** This generates the index.html file used for presenting the frame-formated
<a name="line22"></a> * "cover page" of the API documentation.
<a name="line23"></a> *
<a name="line24"></a> * @package PHPDoctor\Doclets\Standard
<a name="line25"></a> */
<a name="line26"></a>class HTMLWriter
<a name="line27"></a>{
<a name="line28"></a>
<a name="line29"></a>	/** The doclet that created this object.
<a name="line30"></a>	 *
<a name="line31"></a>	 * @var doclet
<a name="line32"></a>	 */
<a name="line33"></a>	var $_doclet;
<a name="line34"></a>
<a name="line35"></a>	/** The section titles to place in the header and footer.
<a name="line36"></a>	 *
<a name="line37"></a>	 * @var str[][]
<a name="line38"></a>	 */
<a name="line39"></a>	var $_sections = NULL;
<a name="line40"></a>
<a name="line41"></a>	/** The directory structure depth. Used to calculate relative paths.
<a name="line42"></a>	 *
<a name="line43"></a>	 * @var int
<a name="line44"></a>	 */
<a name="line45"></a>	var $_depth = 0;
<a name="line46"></a>
<a name="line47"></a>	/** The <body> id attribute value, used for selecting style.
<a name="line48"></a>	 *
<a name="line49"></a>	 * @var str
<a name="line50"></a>	 */
<a name="line51"></a>	var $_id = 'overview';
<a name="line52"></a>
<a name="line53"></a>	/** The output body.
<a name="line54"></a>	 *
<a name="line55"></a>	 * @var str
<a name="line56"></a>	 */
<a name="line57"></a>	var $_output = '';
<a name="line58"></a>
<a name="line59"></a>	/** Writer constructor.
<a name="line60"></a>	 */
<a name="line61"></a>	function htmlWriter(&$doclet)
<a name="line62"></a>    {
<a name="line63"></a>		$this->_doclet =& $doclet;
<a name="line64"></a>	}
<a name="line65"></a>
<a name="line66"></a>	/** Build the HTML header. Includes doctype definition, <html> and <head>
<a name="line67"></a>	 * sections, meta data and window title.
<a name="line68"></a>	 *
<a name="line69"></a>	 * @return str
<a name="line70"></a>	 */
<a name="line71"></a>	function _htmlHeader($title)
<a name="line72"></a>    {
<a name="line73"></a>	
<a name="line74"></a>		$output = $this->_doctype();
<a name="line75"></a>		$output .= '<html lang="en">'."\n";
<a name="line76"></a>		$output .= "<head>\n\n";
<a name="line77"></a>		
<a name="line78"></a>		$output .= '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">'."\n\n";
<a name="line79"></a>		$output .= '<meta name="generator" content="PHPDoctor '.$this->_doclet->version().' (http://peej.github.com/phpdoctor/)">'."\n";
<a name="line80"></a>		$output .= '<meta name="when" content="'.gmdate('r').'">'."\n\n";
<a name="line81"></a>		
<a name="line82"></a>		$output .= '<link rel="stylesheet" type="text/css" href="'.str_repeat('../', $this->_depth).'stylesheet.css">'."\n";
<a name="line83"></a>		$output .= '<link rel="start" href="'.str_repeat('../', $this->_depth).'overview-summary.html">'."\n\n";
<a name="line84"></a>		
<a name="line85"></a>		$output .= '<title>';
<a name="line86"></a>		if ($title) {
<a name="line87"></a>			$output .= $title.' ('.$this->_doclet->windowTitle().')';
<a name="line88"></a>		} else {
<a name="line89"></a>			$output .= $this->_doclet->windowTitle();
<a name="line90"></a>		}
<a name="line91"></a>		$output .= "</title>\n\n";
<a name="line92"></a>		$output .= "</head>\n";
<a name="line93"></a>
<a name="line94"></a>		return $output;
<a name="line95"></a>
<a name="line96"></a>	}
<a name="line97"></a>    
<a name="line98"></a>    /** Get the HTML DOCTYPE for this output
<a name="line99"></a>     *
<a name="line100"></a>     * @return str
<a name="line101"></a>     */
<a name="line102"></a>    function _doctype()
<a name="line103"></a>    {
<a name="line104"></a>        return '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">'."\n\n";
<a name="line105"></a>    }
<a name="line106"></a>	
<a name="line107"></a>	/** Build the HTML footer.
<a name="line108"></a>   *
<a name="line109"></a>   * @return str
<a name="line110"></a>   */
<a name="line111"></a>	function _htmlFooter()
<a name="line112"></a>    {
<a name="line113"></a>		return '</html>';
<a name="line114"></a>	}
<a name="line115"></a>
<a name="line116"></a>	/** Build the HTML shell header. Includes beginning of the <body> section,
<a name="line117"></a>	 * and the page header.
<a name="line118"></a>	 *
<a name="line119"></a>	 * @return str
<a name="line120"></a>	 */
<a name="line121"></a>	function _shellHeader($path)
<a name="line122"></a>    {
<a name="line123"></a>		$output = '<body id="'.$this->_id.'" onload="parent.document.title=document.title;">'."\n\n";
<a name="line124"></a>		$output .= $this->_nav($path);
<a name="line125"></a>		return $output;
<a name="line126"></a>	}
<a name="line127"></a>	
<a name="line128"></a>	/** Build the HTML shell footer. Includes the end of the <body> section, and
<a name="line129"></a>	 * page footer.
<a name="line130"></a>	 *
<a name="line131"></a>	 * @return str
<a name="line132"></a>	 */
<a name="line133"></a>	function _shellFooter($path)
<a name="line134"></a>    {
<a name="line135"></a>		$output = $this->_nav($path);
<a name="line136"></a>		$output .= "<hr>\n\n";
<a name="line137"></a>		$output .= '<p id="footer">'.$this->_doclet->bottom().'</p>'."\n\n";
<a name="line138"></a>		$output .= "</body>\n\n";
<a name="line139"></a>		return $output;
<a name="line140"></a>	}
<a name="line141"></a>	
<a name="line142"></a>	/** Build the navigation bar
<a name="line143"></a>	 *
<a name="line144"></a>	 * @return str
<a name="line145"></a>	 */
<a name="line146"></a>	function _nav($path)
<a name="line147"></a>    {
<a name="line148"></a>		$output = '<div class="header">'."\n";
<a name="line149"></a>		$output .= '<h1>'.$this->_doclet->getHeader()."</h1>\n";
<a name="line150"></a>		if ($this->_sections) {
<a name="line151"></a>            $output .= "<ul>\n";
<a name="line152"></a>			foreach ($this->_sections as $section) {
<a name="line153"></a>				if (isset($section['selected']) && $section['selected']) {
<a name="line154"></a>					$output .= '<li class="active">'.$section['title']."</li>\n";
<a name="line155"></a>				} else {
<a name="line156"></a>					if (isset($section['url'])) {
<a name="line157"></a>						$output .= '<li><a href="'.str_repeat('../', $this->_depth).$section['url'].'">'.$section['title']."</a></li>\n";
<a name="line158"></a>					} else {
<a name="line159"></a>						$output .= '<li>'.$section['title'].'</li>';
<a name="line160"></a>					}
<a name="line161"></a>				}
<a name="line162"></a>			}
<a name="line163"></a>            $output .= "</ul>\n";
<a name="line164"></a>		}
<a name="line165"></a>		$output .= "</div>\n\n";
<a name="line166"></a>
<a name="line167"></a>		$output .= '<div class="small_links">'."\n";
<a name="line168"></a>		$output .= '<a href="'.str_repeat('../', $this->_depth).'index.html" target="_top">Frames</a>'."\n";
<a name="line169"></a>		$output .= '<a href="'.str_repeat('../', $this->_depth).$path.'" target="_top">No frames</a>'."\n";
<a name="line170"></a>		$output .= "</div>\n";
<a name="line171"></a>        $thisClass = strtolower(get_class($this));
<a name="line172"></a>		if ($thisClass == 'classwriter') {
<a name="line173"></a>			$output .= '<div class="small_links">'."\n";
<a name="line174"></a>			$output .= 'Summary: <a href="#summary_field">Field</a> | <a href="#summary_method">Method</a> | <a href="#summary_constr">Constr</a>'."\n";
<a name="line175"></a>			$output .= 'Detail: <a href="#detail_field">Field</a> | <a href="#detail_method">Method</a> | <a href="#summary_constr">Constr</a>'."\n";
<a name="line176"></a>			$output .= "</div>\n";
<a name="line177"></a>		} elseif ($thisClass == 'functionwriter') {
<a name="line178"></a>			$output .= '<div class="small_links">'."\n";
<a name="line179"></a>			$output .= 'Summary: <a href="#summary_function">Function</a>'."\n";
<a name="line180"></a>			$output .= 'Detail: <a href="#detail_function">Function</a>'."\n";
<a name="line181"></a>			$output .= "</div>\n";
<a name="line182"></a>		} elseif ($thisClass == 'globalwriter') {
<a name="line183"></a>			$output .= '<div class="small_links">'."\n";
<a name="line184"></a>			$output .= 'Summary: <a href="#summary_global">Global</a>'."\n";
<a name="line185"></a>			$output .= 'Detail: <a href="#detail_global">Global</a>'."\n";
<a name="line186"></a>			$output .= "</div>\n";
<a name="line187"></a>		}
<a name="line188"></a>
<a name="line189"></a>		return $output;
<a name="line190"></a>	}
<a name="line191"></a>	
<a name="line192"></a>	function _sourceLocation($doc)
<a name="line193"></a>	{
<a name="line194"></a>	    if ($this->_doclet->includeSource()) {
<a name="line195"></a>	        $url = strtolower(str_replace(DIRECTORY_SEPARATOR, '/', $doc->sourceFilename()));
<a name="line196"></a>	        echo '<a href="', str_repeat('../', $this->_depth), 'source/', $url, '.html#line', $doc->sourceLine(), '" class="location">', $doc->location(), "</a>\n\n";
<a name="line197"></a>	    } else {
<a name="line198"></a>	        echo '<div class="location">', $doc->location(), "</div>\n";
<a name="line199"></a>	    }
<a name="line200"></a>	}
<a name="line201"></a>
<a name="line202"></a>	/** Write the HTML page to disk using the given path.
<a name="line203"></a>	 *
<a name="line204"></a>	 * @param str path The path to write the file to
<a name="line205"></a>	 * @param str title The title for this page
<a name="line206"></a>	 * @param bool shell Include the page shell in the output
<a name="line207"></a>	 */
<a name="line208"></a>	function _write($path, $title, $shell)
<a name="line209"></a>    {
<a name="line210"></a>		$phpdoctor =& $this->_doclet->phpdoctor();
<a name="line211"></a>		
<a name="line212"></a>		// make directory separators suitable to this platform
<a name="line213"></a>		$path = str_replace('/', DIRECTORY_SEPARATOR, $path);
<a name="line214"></a>		
<a name="line215"></a>		// make directories if they don't exist
<a name="line216"></a>		$dirs = explode(DIRECTORY_SEPARATOR, $path);
<a name="line217"></a>		array_pop($dirs);
<a name="line218"></a>		$testPath = $this->_doclet->destinationPath();
<a name="line219"></a>		foreach ($dirs as $dir) {
<a name="line220"></a>			$testPath .= $dir.DIRECTORY_SEPARATOR;
<a name="line221"></a>			if (!is_dir($testPath)) {
<a name="line222"></a>                if (!@mkdir($testPath)) {
<a name="line223"></a>                    $phpdoctor->error(sprintf('Could not create directory "%s"', $testPath));
<a name="line224"></a>                    exit;
<a name="line225"></a>                }
<a name="line226"></a>            }
<a name="line227"></a>		}
<a name="line228"></a>		
<a name="line229"></a>		// write file
<a name="line230"></a>		$fp = fopen($this->_doclet->destinationPath().$path, 'w');
<a name="line231"></a>		if ($fp) {
<a name="line232"></a>			$phpdoctor->message('Writing "'.$path.'"');
<a name="line233"></a>			fwrite($fp, $this->_htmlHeader($title));
<a name="line234"></a>			if ($shell) fwrite($fp, $this->_shellHeader($path));
<a name="line235"></a>			fwrite($fp, $this->_output);
<a name="line236"></a>			if ($shell) fwrite($fp, $this->_shellFooter($path));
<a name="line237"></a>			fwrite($fp, $this->_htmlFooter());
<a name="line238"></a>			fclose($fp);
<a name="line239"></a>		} else {
<a name="line240"></a>			$phpdoctor->error('Could not write "'.$this->_doclet->destinationPath().$path.'"');
<a name="line241"></a>            exit;
<a name="line242"></a>		}
<a name="line243"></a>	}
<a name="line244"></a>	
<a name="line245"></a>	/** Format tags for output.
<a name="line246"></a>	 *
<a name="line247"></a>	 * @param Tag[] tags
<a name="line248"></a>	 * @return str The string representation of the elements doc tags
<a name="line249"></a>	 */
<a name="line250"></a>	function _processTags(&$tags)
<a name="line251"></a>    {
<a name="line252"></a>		$tagString = '';
<a name="line253"></a>		foreach ($tags as $key => $tag) {
<a name="line254"></a>			if ($key != '@text') {
<a name="line255"></a>				if (is_array($tag)) {
<a name="line256"></a>                    $hasText = FALSE;
<a name="line257"></a>                    foreach ($tag as $key => $tagFromGroup) {
<a name="line258"></a>                        if ($tagFromGroup->text($this->_doclet) != '') {
<a name="line259"></a>                            $hasText = TRUE;
<a name="line260"></a>                        }
<a name="line261"></a>                    }
<a name="line262"></a>                    if ($hasText) {
<a name="line263"></a>                        $tagString .= '<dt>'.$tag[0]->displayName().":</dt>\n";
<a name="line264"></a>                        foreach ($tag as $tagFromGroup) {
<a name="line265"></a>                            $tagString .= '<dd>'.$tagFromGroup->text($this->_doclet)."</dd>\n";
<a name="line266"></a>                        }
<a name="line267"></a>                    }
<a name="line268"></a>				} else {
<a name="line269"></a>					$text = $tag->text($this->_doclet);
<a name="line270"></a>					if ($text != '') {
<a name="line271"></a>						$tagString .= '<dt>'.$tag->displayName().":</dt>\n";
<a name="line272"></a>						$tagString .= '<dd>'.$text."</dd>\n";
<a name="line273"></a>					} elseif ($tag->displayEmpty()) {
<a name="line274"></a>						$tagString .= '<dt>'.$tag->displayName().".</dt>\n";
<a name="line275"></a>					}
<a name="line276"></a>				}
<a name="line277"></a>			}
<a name="line278"></a>		}
<a name="line279"></a>        if ($tagString) {
<a name="line280"></a>            echo "<dl>\n", $tagString, "</dl>\n";
<a name="line281"></a>        }
<a name="line282"></a>	}
<a name="line283"></a>	
<a name="line284"></a>	/** Convert inline tags into a string for outputting.
<a name="line285"></a>	 *
<a name="line286"></a>	 * @param Tag tag The text tag to process
<a name="line287"></a>	 * @param bool first Process first line of tag only
<a name="line288"></a>	 * @return str The string representation of the elements doc tags
<a name="line289"></a>	 */
<a name="line290"></a>	function _processInlineTags(&$tag, $first = FALSE)
<a name="line291"></a>    {
<a name="line292"></a>		if ($tag) {
<a name="line293"></a>			$description = '';
<a name="line294"></a>			if ($first) {
<a name="line295"></a>				$tags =& $tag->firstSentenceTags($this->_doclet);
<a name="line296"></a>			} else {
<a name="line297"></a>				$tags =& $tag->inlineTags($this->_doclet);
<a name="line298"></a>			}
<a name="line299"></a>            if ($tags) {
<a name="line300"></a>				foreach ($tags as $aTag) {
<a name="line301"></a>					if ($aTag) {
<a name="line302"></a>						$description .= $aTag->text($this->_doclet);
<a name="line303"></a>					}
<a name="line304"></a>				}
<a name="line305"></a>			}
<a name="line306"></a>            return $this->_doclet->formatter->toFormattedText($description);
<a name="line307"></a>		}
<a name="line308"></a>		return NULL;
<a name="line309"></a>	}
<a name="line310"></a>    
<a name="line311"></a>}
<a name="line312"></a>
<a name="line313"></a>?>
<a name="line314"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/standard/htmlwriter.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>